/* Tabela cOMANDAFOS: TABELA DE COMANDA */
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela COMANDAFOS */
/* Objetivo: Gerar um log que vai registrar as alteraes na COMANDAFOS,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_COMANDAFOS
AFTER DELETE OR INSERT OR UPDATE
ON COMANDAFOS FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
		IF NVL(:NEW.CDFILIAL ,'NULL') <> NVL(:OLD.CDFILIAL ,'NULL') THEN
			V_DESC := 'Filial ' || '' || NVL(:NEW.CDFILIAL,'');
		END IF;
		IF NVL(:NEW.CDLOJA ,'NULL') <> NVL(:OLD.CDLOJA ,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Loja  ' || '' || NVL(:NEW.CDLOJA,'');
		END IF;
		IF NVL(:NEW.DSCOMANDAFOS ,'NULL') <> NVL(:OLD.DSCOMANDAFOS ,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Cd Comanda ' || '' || NVL(:NEW.DSCOMANDAFOS,'');
		END IF;
		IF NVL(:NEW.DSOBSCOMANDAFOS ,'NULL') <> NVL(:OLD.DSOBSCOMANDAFOS ,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Observao Comanda  ' || '' || NVL(:NEW.DSOBSCOMANDAFOS,'');
		END IF;
		IF NVL(:NEW.DTSITCOMANDAFOS ,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTSITCOMANDAFOS ,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Dt situao  ' || '' || NVL(:NEW.DTSITCOMANDAFOS,'');
		END IF;
		IF NVL(:NEW.CDOPERADOR ,'NULL') <> NVL(:OLD.CDOPERADOR ,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Cd Operador ' || '' || NVL(:NEW.CDOPERADOR,'');
		END IF;
		IF NVL(:NEW.IDSITCOMANDAFOS ,'NULL') <> NVL(:OLD.IDSITCOMANDAFOS ,'NULL') THEN 
            V_DESC := NVL(V_DESC, '') || ' ' || 'Situao Comanda ' || '' || NVL(:NEW.IDSITCOMANDAFOS,'');
		END IF;
		IF NVL(:NEW.DTULTATUCOMANDA ,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTULTATUCOMANDA ,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Dt Ult Atu Camanda' || '' || NVL(:NEW.DTULTATUCOMANDA,'');
		END IF;
      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDLOJA||:NEW.DSCOMANDAFOS;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Filial '               || '' || NVL(:NEW.CDFILIAL,''    )       || ' ' ||
                  'Loja  '                || '' || NVL(:NEW.CDLOJA,''      )       || ' ' ||
                  'Cd Comanda '           || '' || NVL(:NEW.DSCOMANDAFOS,'' )      || ' ' ||
                  'Observao Comanda  '  || '' || NVL(:NEW.DSOBSCOMANDAFOS,'')    || ' ' ||
                  'Dt situao  '         || '' || NVL(:NEW.DTSITCOMANDAFOS,''  )  || ' ' ||
                  'Cd Operador '          || '' || NVL(:NEW.CDOPERADOR,''  )       || ' ' ||
                  'Situao Comanda '     || '' || NVL(:NEW.IDSITCOMANDAFOS,'')    || ' ' ||
                  'Dt Ult Atu Camanda'    || '' || NVL(:NEW.DTULTATUCOMANDA,'');
      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDLOJA||:NEW.DSCOMANDAFOS;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Filial '               || '' || NVL(:OLD.CDFILIAL,''    )       || ' ' ||
                  'Loja  '                || '' || NVL(:OLD.CDLOJA,''      )       || ' ' ||
                  'Cd Comanda '           || '' || NVL(:OLD.DSCOMANDAFOS,'' )      || ' ' ||
                  'Observao Comanda  '  || '' || NVL(:OLD.DSOBSCOMANDAFOS,'')    || ' ' ||
                  'Dt situao  '         || '' || NVL(:OLD.DTSITCOMANDAFOS,''  )  || ' ' ||
                  'Cd Operador '          || '' || NVL(:OLD.CDOPERADOR,''  )       || ' ' ||
                  'Situao Comanda '     || '' || NVL(:OLD.IDSITCOMANDAFOS,'')    || ' ' ||
                  'Dt Ult Atu Camanda'    || '' || NVL(:OLD.DTULTATUCOMANDA,'');
      V_ITPESQ := :OLD.CDFILIAL||:OLD.CDLOJA||:OLD.DSCOMANDAFOS;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND,
       CDFILLOGOPERVND)
   VALUES
      ('COMANDAFOS',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_COMANDAFOS','5.20.001'); END;
/
