/* Tabela ALIQIMPFIS: TABELA DE ALIQUOTAS DA IMPRESSORA*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela ALIQIMPFIS */
/* Objetivo: Gerar um log que vai registrar as alteraes na ALIQIMPFIS,
             utilizando a tabela de Logs de Operaes do VND*/
             
CREATE OR REPLACE TRIGGER LOG_VND_ALIQIMPFIS
AFTER DELETE OR INSERT OR UPDATE
ON ALIQIMPFIS FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF UPDATING THEN

		IF NVL(:NEW.CDFILIAL ,'NULL') <> NVL(:OLD.CDFILIAL ,'NULL') THEN
			V_DESC   := 'Filial ' || '' || NVL(:NEW.CDFILIAL,'');
		END IF;
		IF NVL(:NEW.CDPRODUTO ,'NULL') <> NVL(:OLD.CDPRODUTO ,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Cd Produto ' || '' || NVL(:NEW.CDPRODUTO,'');
		END IF;
		IF NVL(:NEW.VRPEALIMPFIS ,999999) <> NVL(:OLD.VRPEALIMPFIS ,999999) THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Vr do Imposto ' || '' || NVL(:NEW.VRPEALIMPFIS,'');
		END IF;
		IF NVL(:NEW.CDIMPOSTO ,'NULL') <> NVL(:OLD.CDIMPOSTO ,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Cd Imposto ' || '' || NVL(:NEW.CDIMPOSTO,'');
		END IF;
		IF NVL(:NEW.DTULTATUALIF ,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTULTATUALIF ,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Dt Ult Atu Imposto ' || '' || NVL(:NEW.DTULTATUALIF,'');
		END IF;
		IF NVL(:NEW.VRALIQIBPT,999999) <> NVL(:OLD.VRALIQIBPT,999999) THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'IBPT (Federal) ' || '' || NVL(:NEW.VRALIQIBPT,'');
		END IF;
		IF NVL(:NEW.VRALIQIBPTES,999999) <> NVL(:OLD.VRALIQIBPTES,999999) THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'IBPT (Estadual) ' || '' || NVL(:NEW.VRALIQIBPTES,'');
		END IF;
		IF NVL(:NEW.CDCSTICMS,'NULL') <> NVL(:OLD.CDCSTICMS,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'CST/CSOSN (ICMS) ' || '' || NVL(:NEW.CDCSTICMS,'');
		END IF;
		IF NVL(:NEW.CDCSTPISCOF,'NULL') <> NVL(:OLD.CDCSTPISCOF,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'CST (PIS/COFINS) ' || '' || NVL(:NEW.CDCSTPISCOF,'');
		END IF;
		IF NVL(:NEW.CDCFOPPFIS,'NULL') <> NVL(:OLD.CDCFOPPFIS,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'CFOP ' || '' || NVL(:NEW.CDCFOPPFIS,'');
		END IF;
		IF NVL(:NEW.VRALIQPIS,999999) <> NVL(:OLD.VRALIQPIS,999999) THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Alq. PIS ' || '' || NVL(:NEW.VRALIQPIS,'');
		END IF;
		IF NVL(:NEW.VRALIQCOFINS,999999) <> NVL(:OLD.VRALIQCOFINS,999999) THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Alq. COFINS ' || '' || NVL(:NEW.VRALIQCOFINS,'');
		END IF;
		IF NVL(:NEW.VRPERCREDUCAO,999999) <> NVL(:OLD.VRPERCREDUCAO,999999) THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Perc. Reduo (ICMS) ' || '' || NVL(:NEW.VRPERCREDUCAO,'');
		END IF;
		IF NVL(:NEW.CDCEST,'NULL') <> NVL(:OLD.CDCEST,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'CEST ' || '' || NVL(:NEW.CDCEST,'');
		END IF;
		IF NVL(:NEW.IDTPIMPOSFIS ,'NULL') <> NVL(:OLD.IDTPIMPOSFIS ,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'Id Imposto Impressora ' || '' || NVL(:NEW.IDTPIMPOSFIS,'');
		END IF;
    IF NVL(:NEW.CDREGRAIT ,'NULL') <> NVL(:OLD.CDREGRAIT ,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'CDREGRAIT ' || '' || NVL(:NEW.CDREGRAIT,'');
    END IF;
    IF NVL(:NEW.IDMODALBASECALC ,'NULL') <> NVL(:OLD.IDMODALBASECALC ,'NULL') THEN
            V_DESC := NVL(V_DESC, '') || ' ' || 'IDMODALBASECALC ' || '' || NVL(:NEW.IDMODALBASECALC,'');
    END IF;


      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDPRODUTO||:NEW.CDIMPOSTO;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Filial '                || '' || NVL(:NEW.CDFILIAL     ,'') || ' ' ||
                  'Cd Produto  '           || '' || NVL(:NEW.CDPRODUTO    ,'') || ' ' ||
                  'Vr do Imposto  '        || '' || NVL(:NEW.VRPEALIMPFIS ,'') || ' ' ||
                  'Cd Imposto  '           || '' || NVL(:NEW.CDIMPOSTO    ,'') || ' ' ||
                  'Dt Ult Atu Imposto '    || '' || NVL(:NEW.DTULTATUALIF ,'') || ' ' ||
                  'IBPT (Federal) '        || '' || NVL(:NEW.VRALIQIBPT   ,'') || ' ' ||
                  'IBPT (Estadual) '       || '' || NVL(:NEW.VRALIQIBPTES ,'') || ' ' ||
                  'CST/CSOSN (ICMS) '      || '' || NVL(:NEW.CDCSTICMS    ,'') || ' ' ||
                  'CST (PIS/COFINS) '      || '' || NVL(:NEW.CDCSTPISCOF  ,'') || ' ' ||
                  'CFOP '                  || '' || NVL(:NEW.CDCFOPPFIS   ,'') || ' ' ||
                  'Alq. PIS '             || '' || NVL(:NEW.VRALIQPIS    ,'') || ' ' ||
                  'Alq. COFINS '          || '' || NVL(:NEW.VRALIQCOFINS ,'') || ' ' ||
                  'Perc. Reduo (ICMS) '  || '' || NVL(:NEW.VRPERCREDUCAO,'') || ' ' || 
                  'CEST '                  || '' || NVL(:NEW.CDCEST       ,'') || ' ' ||
                  'IDMODALBASECALC '       || '' || NVL(:NEW.IDMODALBASECALC ,'') || ' ' ||
                  'CDREGRAIT '             || '' || NVL(:NEW.CDREGRAIT ,'') || ' ' ||
                  'Id Imposto Impressora ' || '' || NVL(:NEW.IDTPIMPOSFIS ,'');
      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDPRODUTO||:NEW.CDIMPOSTO;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Filial '                || '' || NVL(:OLD.CDFILIAL     ,'') || ' ' ||
                  'Cd Produto  '           || '' || NVL(:OLD.CDPRODUTO    ,'') || ' ' ||
                  'Vr do Imposto  '        || '' || NVL(:OLD.VRPEALIMPFIS ,'') || ' ' ||
                  'Cd Imposto  '           || '' || NVL(:OLD.CDIMPOSTO    ,'') || ' ' ||
                  'Dt Ult Atu Imposto '    || '' || NVL(:OLD.DTULTATUALIF ,'') || ' ' ||
                  'IBPT (Federal) '        || '' || NVL(:OLD.VRALIQIBPT   ,'') || ' ' ||
                  'IBPT (Estadual) '       || '' || NVL(:OLD.VRALIQIBPTES ,'') || ' ' ||
                  'CST/CSOSN (ICMS) '      || '' || NVL(:OLD.CDCSTICMS    ,'') || ' ' ||
                  'CST (PIS/COFINS) '      || '' || NVL(:OLD.CDCSTPISCOF  ,'') || ' ' ||
                  'CFOP '                  || '' || NVL(:OLD.CDCFOPPFIS   ,'') || ' ' ||
                  'Alq. PIS '             || '' || NVL(:OLD.VRALIQPIS    ,'') || ' ' ||
                  'Alq. COFINS '          || '' || NVL(:OLD.VRALIQCOFINS ,'') || ' ' ||
                  'Perc. Reduo (ICMS) '  || '' || NVL(:OLD.VRPERCREDUCAO,'') || ' ' ||
                  'CEST '                  || '' || NVL(:OLD.CDCEST       ,'') || ' ' ||
                  'Id Imposto Impressora ' || '' || NVL(:OLD.IDTPIMPOSFIS ,'') || ' ' ||
                  'IDMODALBASECALC '       || '' || NVL(:OLD.IDMODALBASECALC ,'') || ' ' ||
                  'CDREGRAIT '             || '' || NVL(:OLD.CDREGRAIT ,'');
      V_ITPESQ := :OLD.CDFILIAL||:OLD.CDPRODUTO||:OLD.CDIMPOSTO;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND,
       CDFILLOGOPERVND)
   VALUES
      ('ALIQIMPFIS',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       NVL(:NEW.CDFILIAL,:OLD.CDFILIAL));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_ALIQIMPFIS','6.05.xxx'); END;
/
