var Exp00100_lancamentoExpedicaoItem_Controller = function(General, templateManager, ScreenService, Exp00100_lancamentoExpedicaoItem_Service, ZHPromise, ZhFilterPreferences, MessageService) {

    this.filterOnEnter = function(widget){
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilialLogadaFilter(widget);
            this.filterAdjustment();
        }.bind(this)); 
    };

    this.setFilialLogadaFilter = function (widget){
        Exp00100_lancamentoExpedicaoItem_Service.getFilialLogada().then(function(filialLogada) {
            if (filialLogada[0]) {
                var widget = templateManager.container.getWidget('expedicaoPedido');
                templateManager.container.getActiveWidget().currentRow.CDFILIAL = filialLogada[0].CDFILIAL;
                templateManager.container.getActiveWidget().currentRow.NMFILIAL = filialLogada[0].NMFILIAL;
                
                this.setSerieFilter(widget);
                Exp00100_lancamentoExpedicaoItem_Service.retornaEmpresa(filialLogada[0].CDEMPRESA).then(function(empresa) {
                    
                    templateManager.container.getActiveWidget().currentRow.CDEMPRESA = empresa[0].CDEMPRESA;
                    templateManager.container.getActiveWidget().currentRow.NMEMPRESA = empresa[0].NMEMPRESA;
                }.bind(this));
            } else {
                ScreenService.showMessage('Erro ao buscar Filial Logada, escolha manualmente.');
            }
        }.bind(this));
    };
    
    this.filterAdjustment = function (){
        Exp00100_lancamentoExpedicaoItem_Service.getFilialLogada().then(function(filialLogada) {
            var cdfilial = filialLogada[0].CDFILIAL;
            var widget = templateManager.container.getWidget('expedicaoPedido');
            var widgetFiltro = templateManager.container.getActiveWidget();
            if (widgetFiltro && widgetFiltro.currentRow.CDFILIAL && filialLogada[0].CDFILIAL !== widgetFiltro.currentRow.CDFILIAL) {
                cdfilial = widgetFiltro.currentRow.CDFILIAL;
            }
            var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ];
            widgetFiltro.currentRow.CDSERIE = '';
            widgetFiltro.currentRow.DSSERIE = '';
            this.setSerieFilter2(filter);
            General.callRestEngine('ped#/crud/parampedido', "FilterData", filter).then(function(callback){
                var params = callback.dataset.parampedido;
                // widget.transportadora = params[0].NRINSJURTRAN;
                if (params[0] && params[0].IDOBRTPOPPED == 'N'){
                    widget.getField('NMTIPOOPER').requiredParam = true;
                    widgetFiltro.getField('NMTIPOOPER').validations = {
                        required: true
                    };
                    widgetFiltro.getField('NMTIPOOPER').reload();
                } else if (params[0]){
                    widget.getField('NMTIPOOPER').requiredParam = false;
                    delete widgetFiltro.getField('NMTIPOOPER').validations;
                } else {
                    ScreenService.showMessage('Não foi encontrada nenhuma parametrização para a Filial escolhida.');
                }
            }.bind(this)).catch(function(callback){
                ScreenService.showMessage(callback.dataset.error);
            });
        }.bind(this)).catch(function(callback){
            ScreenService.showMessage(callback.dataset.error);
        }.bind(this));
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Exp00100_lancamentoExpedicaoItem_Controller', Exp00100_lancamentoExpedicaoItem_Controller);
});