var  ped05900_composicao_preco_produto_Controller = function(ScreenService, ZhFilterPreferences, ped05900_composicao_preco_produto_Service, General, templateManager, ZHPromise, localStorageEngine,
                                                        restEngine, MessageService){
                                                            
    this.valor = '';
    this.position = [];

    this.startFiltering = function(widget){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilter(widget);
        }.bind(this)); 
    };
    
    this.setFilter = function(widget) {
        var filterRow = {};
        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            filterRow.CDFILIAL = response.dataset.filial[0].CDFILIAL;
            filterRow.NMFILIAL = response.dataset.filial[0].NMFILIAL;
            templateManager.container.getActiveWidget().currentRow = filterRow;
        }.bind(this));
    };

    
    this.setDefaultTab = function(){
        var widget = templateManager.container.getWidget('widgetComposicao');
        widget.activate();
        widget.reload();
    };
    
    this.getOperadorLogado = function(){
        
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        
        return General.callRestEngine("ped#/crud/operador", 'FilterData', filter);
	};
    
    this.setDefaultValue = function(widget){
        widget.getField('NMITFORPRECO').readOnly = false;
        widget.getField('VRPEFORMPREC').readOnly = false;
        widget.getField('VRFATFORMPREC').readOnly = false;
        widget.getField('VRPEFORMPREC').setValue('0');
        widget.getField('VRFATFORMPREC').setValue('0');

    };
    this.editCompPreco = function(widget){
        widget.getField('VRPEFORMPREC').readOnly = false;
        widget.getField('VRFATFORMPREC').readOnly = false;
        widget.getField('NMITFORPRECO').readOnly = true;
        General.edit(widget);
    };
    
    this.disableField = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.VRPEFORMPREC != 0 && widget.currentRow.VRFATFORMPREC == 0 ){
            if(widget.currentRow.VRPEFORMPREC > 100){
                ScreenService.showMessage('O Percentual de Composição do Preço do Produto não pode ser maior que 100.');
                widget.getField('VRPEFORMPREC'). setValue('0');
            }else{
                widget.getField('VRFATFORMPREC').readOnly = true;
            }
        }else if (widget.currentRow.VRFATFORMPREC != 0 && widget.currentRow.VRPEFORMPREC == 0){
            widget.getField('VRPEFORMPREC').readOnly = true;
        }
    };
    
    this.openPopupformulaCalcPreco = function(){
        var widgetFormCalc = templateManager.container.getWidget('widgetFormCalc');
        
        widgetFormCalc.activate();
        widgetFormCalc.reload();
        
        //templateManager.container.getWidget('widgetFormula').getField('DSFORMCALCPRECO').setValue(this.valor);
        
        ScreenService.openPopup(widgetFormCalc);
        $(document).keydown(function(e) { return false; });
    };
    this.closePopupFormula = function(){
        var widgetComposicao = templateManager.container.getWidget('widgetComposicao');
        var widgetFormula = templateManager.container.getWidget('widgetFormula');
        var fieldsForm = widgetFormula.fields;

        fieldsForm.splice(3, fieldsForm.length);

        /*fieldsForm.forEach(function(f){
            if(f.name != "DSFORMCALCPRECO" && f.name !="BUTTON_DEFAULT" && f.name !="PC"){
                widgetFormula.fields.pop();
            }
        });*/

        ScreenService.closePopup();
        widgetComposicao.activate();
        widgetFormula.reload();
        widgetComposicao.reload();
        templateManager.updateTemplate();
    };
    
    this.setDataSourceFilterApply = function(args){
        var widgetProduto = templateManager.container.getWidget('widgetProduto');
         if(templateManager.container.getActiveWidget().isValid()){
            var rowPopup = templateManager.container.getActiveWidget().currentRow;
            var dataSourceFilter= [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": rowPopup.CDFILIAL
                }
            ];
            
            widgetProduto.dataSourceFilter = dataSourceFilter;
            widgetProduto.currentRow.CDTIPOCUSTO = rowPopup.CDTIPOCUSTO;
            widgetProduto.currentRow.CDFILIAL = rowPopup.CDFILIAL;
            widgetProduto.reload();
         }
    };
    
    this.openWindowCalculo= function(){
        
        var widgetProduto = templateManager.containers['ped_pedidos#ped05900_composicao_preco_produto'].getWidget('widgetProduto');
        var tipoCusto = widgetProduto.currentRow.CDTIPOCUSTO;
        var filial = widgetProduto.currentRow.CDFILIAL;
        widgetProduto.deactivate();
        widgetProduto.isVisible = false;
         
        ScreenService.openWindow('ped_pedidos#ped05900_composicao_preco_produto_calc').then(function(){
            var widgetCalculoPreco = templateManager.containers['ped_pedidos#ped05900_composicao_preco_produto_calc'].getWidget('widgetCalculo');
            widgetCalculoPreco.activate();
            widgetCalculoPreco.isVisible = true;
            
            widgetCalculoPreco.getField('IDTPCALCPREBASE').setValue('T');
            widgetCalculoPreco.currentRow.IDTPCALCPREBASE = "T";
            widgetCalculoPreco.currentRow.DTINIVALIPB = moment().format('DD/MM/YYYY');
            widgetCalculoPreco.getField('TTCDPRODUTO').setValue('I');
            widgetCalculoPreco.currentRow.TTCDPRODUTO = "I";
            widgetCalculoPreco.currentRow.CDTIPOCUSTO = tipoCusto;
            widgetCalculoPreco.currentRow.CDFILIAL = filial;

        });
    };
    this.closeWindowCalculo = function(){
        var widgetCalculo = templateManager.container.getWidget('widgetCalculo');
        var widgetListaCalc = templateManager.container.getWidget('listaCalcPreco');
        
        widgetCalculo.getField('NMPRODINI').clearValue();
        widgetCalculo.getField('NMPRODFIN').clearValue();
        widgetCalculo.currentRow.CDPRODUTOINI = "";
        widgetCalculo.currentRow.CDPRODUTOFIN = "";
        
        widgetCalculo.isVisible = false;
        widgetCalculo.deactivate();
        widgetListaCalc.dataSource.data = [];
        widgetCalculo.currentRow = {};
        widgetCalculo.reload();

        ScreenService.openWindow('ped_pedidos#ped05900_composicao_preco_produto').then(function(){
            
            var widgetProduto = templateManager.container.getWidget('widgetProduto');
            widgetProduto.isVisible = true;
            widgetProduto.activate();
            this.setDataSourceFilterApply();
            widgetProduto.reload();
        }.bind(this));
    };
    this.enableField = function(){
       var widgetCalculo = templateManager.containers['ped_pedidos#ped05900_composicao_preco_produto_calc'].getWidget('widgetCalculo');
       if(widgetCalculo.currentRow.IDTPCALCPREBASE == 'L'){
           widgetCalculo.getField('CDPRECOBASE').readOnlyOnEdit = false;
           widgetCalculo.getField('CDPRECOBASE').validations = {required:true};
       }else{
           widgetCalculo.getField('CDPRECOBASE').readOnlyOnEdit = true;
           widgetCalculo.getField('CDPRECOBASE').validations = {};
       }
       
       if(widgetCalculo.currentRow.TTCDPRODUTO == 'I'){
           widgetCalculo.getField('NMPRODINI').readOnly = false;
           widgetCalculo.getField('NMPRODINI').validations = {required:true};
       }else{
           widgetCalculo.getField('NMPRODINI').readOnly = true;
           widgetCalculo.getField('NMPRODINI').validations = {};
           this.setDataSourceFilter();
       }
       
       if(widgetCalculo.currentRow.NMPRODINI){
            widgetCalculo.getField('NMPRODFIN').readOnly = false;
            widgetCalculo.getField('NMPRODFIN').validations = {required:true};
       }else{
           widgetCalculo.getField('NMPRODFIN').readOnly = true;
           widgetCalculo.getField('NMPRODFIN').validations = {};
           widgetCalculo.getField('NMPRODFIN').setValue("");
           widgetCalculo.currentRow.NMPRODFIN = "";
       }
    };
    
    this.setDataSourceFilter = function(){
        var widgetCalculo = templateManager.container.getWidget('widgetCalculo');
        var widgetListaCalc = templateManager.container.getWidget('listaCalcPreco');
        
        var row = [];
        
        if(widgetCalculo.currentRow.NMPRODFIN){
            if(widgetCalculo.currentRow.P_CDPRODUTOINI > widgetCalculo.currentRow.P_CDPRODUTOFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                widgetCalculo.getField('NMPRODFIN').setValue("");
                return 0;
            }
        }
        
        
        if(widgetCalculo.currentRow.TTCDPRODUTO == 'I'){
            row.push(
                {
                    TODOSLISTA: null,
                    CDPRODUTO: null,
                    CDTIPOCUSTO: widgetCalculo.currentRow.CDTIPOCUSTO,
                    CDFILIAL: widgetCalculo.currentRow.CDFILIAL,
                    CDARVPRODINI: widgetCalculo.currentRow.CDPRODUTOINI,
                    CDARVPRODFIN: widgetCalculo.currentRow.CDPRODUTOFIN,
                    TCDPRODUTO:"T",
                    TTCDPRODUTO:null
                 }
            );
        }else{
            row.push(
                {
                    CDPRODUTO: null,
                    TODOSLISTA: null,
                    CDTIPOCUSTO: widgetCalculo.currentRow.CDTIPOCUSTO,
                    CDFILIAL: widgetCalculo.currentRow.CDFILIAL,
                    CDARVPRODINI: null,
                    CDARVPRODFIN: null,
                    TTCDPRODUTO: widgetCalculo.currentRow.TTCDPRODUTO,
                    TCDPRODUTO:"T"
                }
            );
        }
        
        ped05900_composicao_preco_produto_Service.openGridCalc(row).then(function(response){
            widgetListaCalc.dataSource.data = response.dataset.dataSetComp;
            widgetListaCalc.reload();
        });
    };
    
    this.createFields = function(){
        var widgetFormula = templateManager.container.getWidget('widgetFormula');
        var composicao = templateManager.container.getWidget('widgetComposicao').dataSource.data;
        var calculadora = templateManager.container.getWidget('widgetCalculadora');

        composicao.forEach(function(field){
            var newButtom = Object.assign({}, widgetFormula.getField('BUTTON_DEFAULT'));
            
            newButtom.name = field.SGITFORPRECO;
            newButtom.label = field.NMITFORPRECO;
            newButtom.isVisible = true;
            newButtom.showOnForm = true;
            newButtom.valueField = field.SGITFORPRECO; 
            newButtom.decriptionField = field.NMITFORPRECO;
            
            widgetFormula.fields.push(newButtom);
        });

        widgetFormula.activate();
        calculadora.activate();
        
        templateManager.updateTemplate();

    };
    
    
    this.atualizaDisplay = function (valor, widgetFormula, field){
        
        widgetFormula.currentRow.DSFORMCALCPRECO = valor;
        widgetFormula.getField('DSFORMCALCPRECO').setValue(valor);
        field.readOnlyOnEdit = false;
        templateManager.updateTemplate();

    };
    
    this.setValueOnClick = function(field, widget){
        field.readOnlyOnEdit = true;
        
        setTimeout(function(){ 
            var valorTecla = field.valueField;
            this.valor +=valorTecla; 
            this.atualizaDisplay(this.valor, widget, field);
        }.bind(this), 1000);
    };
    
    this.backSpaceOnClick = function(field, widget){
        this.valor = this.valor.slice(0,-1);
        this.atualizaDisplay(this.valor, widget, field);
    };
    
    this.deleteOnClick = function(widget, field){
        ScreenService.confirmMessage(ScreenService.i18n('Deseja excluir toda  a fórmula?'), 'question', function (success) {
            this.valor = '';
            this.atualizaDisplay(this.valor, widget, field);
        }.bind(this));
    };
    
    this.salvaFormula = function(){
        var formula = templateManager.container.getWidget('widgetFormula');
        var composicao = templateManager.container.getWidget('widgetProduto');
        
        var row = [{
          CDFILIAL: composicao.currentRow.CDFILIAL,
          CDPRODUTO: composicao.currentRow.CDPRODUTO,
          DSFORMCALCPRECO: formula.currentRow.DSFORMCALCPRECO 
        }];
        
        ped05900_composicao_preco_produto_Service.updateForm(row).then(function(response){
            ScreenService.closePopup();
            ScreenService.showMessage('Fórmula salva com sucesso');
            
        });

    };
    
    this.vereficaChecked = function(){
        var widget = templateManager.container.getWidget('listaCalcPreco');
        var checkedRow = widget.selectedRow;
        var index = widget.getCheckedRows().indexOf(checkedRow);

        if(checkedRow.VRITEPREBASE < 0){
            
            widget.dataSource.checkedRows.splice(index, 1);
            checkedRow.__isSelected = false;
            ScreenService.showMessage('Produtos com valores negativos.');
        }
        
    };
    
    /*global moment*/
    this.calculaPrecoProd = function(){
        var dadosCalculo = templateManager.container.getWidget('widgetCalculo').currentRow;
        var produtosLista = templateManager.container.getWidget('listaCalcPreco').getCheckedRows();
        var hoje = moment().format('DD/MM/YYYY');
        var validade= dadosCalculo.DTINIVALIPB;
        var precoBase = "";
        var row = [];

        hoje = hoje.split("/").reverse("").join("/");
        var valInicial = validade.split("/").reverse("").join("/");
        

        this.getOperadorLogado().then(function(operador){
            var cdoperador = operador.dataset.operador[0].CDOPERADOR;

            if(dadosCalculo.IDTPCALCPREBASE == 'L'){
                precoBase = dadosCalculo.CDPRECOBASE;
    
            }else{
                precoBase = "T";
            }
            
            if(!(precoBase)){
                ScreenService.showMessage("Preço base não informado.");
            }
            if(!(validade)){
                ScreenService.showMessage("Data de validade inicial não informada.");
            }
            if(valInicial < hoje){
                ScreenService.showMessage("Data Inválida. A data inicial não pode ser menor que a atual.");
            }
            if (produtosLista.length == 0){
                ScreenService.showMessage("Produto não informado.");
            }
            /*else{
                produtosLista.forEach(function(produto){
                    if(produto.VRITEPREBASE < 0){
                       templateManager.container.getWidget('listaCalcPreco').unSelectAll();
                       ScreenService.showMessage('Produtos com valores negativos.');
                    }
                    
                });
            }*/
            
            if(dadosCalculo.TTCDPRODUTO == 'I' && dadosCalculo.IDTPCALCPREBASE == 'I'){
                row.push(
                    {
                        TODOSLISTA: null,
                        CDPRODUTO: null,
                        CDTIPOCUSTO: dadosCalculo.CDTIPOCUSTO,
                        CDFILIAL: dadosCalculo.CDFILIAL,
                        CDARVPRODINI: dadosCalculo.CDPRODUTOINI,
                        CDARVPRODFIN: dadosCalculo.CDPRODUTOFIN,
                        TCDPRODUTO:"T",
                        CDPRECOBASE: precoBase,
                        DTINIVALIPB: validade,
                        CDOPERADOR : cdoperador,
                        TTCDPRODUTO:null
                     }
                );
            }else if (dadosCalculo.TTCDPRODUTO == 'I' && dadosCalculo.IDTPCALCPREBASE == 'T'){
                row.push(
                    {
                        TODOSLISTA: null,
                        CDPRODUTO: null,
                        CDTIPOCUSTO: dadosCalculo.CDTIPOCUSTO,
                        CDFILIAL: dadosCalculo.CDFILIAL,
                        CDARVPRODINI: dadosCalculo.CDPRODUTOINI,
                        CDARVPRODFIN: dadosCalculo.CDPRODUTOFIN,
                        TCDPRODUTO:"T",
                        CDPRECOBASE: "T",
                        DTINIVALIPB: validade,
                        CDOPERADOR : cdoperador,
                        TTCDPRODUTO: null
                    }
                );
            }else if (dadosCalculo.TTCDPRODUTO == 'T' && dadosCalculo.IDTPCALCPREBASE == 'I'){
                row.push(
                    {
                        TODOSLISTA: null,
                        CDPRODUTO: null,
                        CDTIPOCUSTO: dadosCalculo.CDTIPOCUSTO,
                        CDFILIAL: dadosCalculo.CDFILIAL,
                        CDARVPRODINI: dadosCalculo.CDPRODUTOINI,
                        CDARVPRODFIN: dadosCalculo.CDPRODUTOFIN,
                        TCDPRODUTO:"T",
                        CDPRECOBASE: precoBase,
                        DTINIVALIPB: validade,
                        CDOPERADOR : cdoperador,
                        TTCDPRODUTO: "T"
                    }
                );
            }else{
                row.push(
                    {
                        TODOSLISTA: null,
                        CDPRODUTO: null,
                        CDTIPOCUSTO: dadosCalculo.CDTIPOCUSTO,
                        CDFILIAL: dadosCalculo.CDFILIAL,
                        CDARVPRODINI: null,
                        CDARVPRODFIN: null,
                        TCDPRODUTO:"T",
                        CDPRECOBASE: "T",
                        DTINIVALIPB: validade,
                        CDOPERADOR : cdoperador,
                        TTCDPRODUTO: "T"
                    }
                );
        }
    
            row.push(produtosLista);
    
            if(templateManager.container.getWidget('widgetCalculo').isValid()){

                ped05900_composicao_preco_produto_Service.calculaPrecoProd(row).then(function(response){
                    var result = response.dataset.dataSetCalc;
                    if(result.length == 0){
                        ScreenService.showMessage('Preço calculado com sucesso!');
                    }
                    
                });
            }
        });    
    };

}; 

Configuration(function(ContextRegister){
    ContextRegister.register('ped05900_composicao_preco_produto_Controller', ped05900_composicao_preco_produto_Controller);
});                                                          